class BasicRouter
  constructor: () ->
    @routeParser = new RouteParser
    @routes = []
  register: (routeString, callback = () ->) ->
    route = @routeParser.parse normalize routeString
    @routes.push [route, callback]
  registerNotFoundHandler: (callback) ->
    @notFoundHandler = callback
  route: (string, args...) ->
    found = false
    for pair in @routes
      [route, callback] = pair
      params = route.match(string)
      if params
        args.unshift params
        callback.apply null, args
        found = true
        break
    if not found and @notFoundHandler
      args.unshift string
      @notFoundHandler.apply null, args
    found